//interrupts.h
#include <iolpc2138.h>

#define VIC_UART0_bit (1 << VIC_UART0)
#define VIC_UART1_bit (1 << VIC_UART1)
#define VIC_EINT0_bit (1 << VIC_EINT0)
#define VIC_EINT1_bit (1 << VIC_EINT1)
#define VIC_EINT2_bit (1 << VIC_EINT2)
#define VIC_RTC_bit   (1 << VIC_RTC)


void VIC_EnableInt(unsigned int IntType);
void VIC_DisableInt(unsigned int IntType);

/**** INTERRUPTS FUNCTION ****/
extern void (*UART0_function)(unsigned char);
extern void (*UART1_function)(unsigned char);
extern void (*EINT0_function)();
extern void (*EINT1_function)();
extern void (*EINT2_function)();
extern void (*RTC_function)();

/**** INIT INTERRUPTS ****/
void InitUART0Interrupt(void(*UART0_func)(unsigned char));
void InitUART1Interrupt(void(*UART1_func)(unsigned char));
void InitEINT0Interrupt(void(*EINT0_func)());
void InitEINT1Interrupt(void(*EINT1_func)());
void InitEINT2Interrupt(void(*EINT2_func)());
void InitRTCInterrupt(void(*RTC_func)());

void UART0Interrupt();
void UART1Interrupt();
void EINT0Interrupt();
void EINT1Interrupt();
void EINT2Interrupt();
void RTCInterrupt();
