/*******************************************************************************
 1. Put extension, remove MMC card
 2. Start program
 3. Remove extension and put MMC card
 4. See report on LCD
 5. AN_TR manage LCD light
 6. RS232_0, RS232_1 - echo
 7. Check power jumper
 8. Check PWM/DAC jumper
 9. NOTICE!!!! Yellow led must blink whit RTC 1 sec ON, 1 sec OFF.... OTHER BLINK TIME INTERVAL
    GIVE ERROR SIGNALS

*******************************************************************************/


#include <iolpc2138.h>
#include "lcd.h"
#include "rs232.h"
#include "mmc.h"
#include "timer.h"
#include "string.h"
#include "rtc.h"
#include "interrupts.h"
#include <inarm.h>

#define   BIT0        0x00000001
#define   BIT1        0x00000002
#define   BIT2        0x00000004
#define   BIT3        0x00000008
#define   BIT4        0x00000010
#define   BIT5        0x00000020
#define   BIT6        0x00000040
#define   BIT7        0x00000080
#define   BIT8        0x00000100
#define   BIT9        0x00000200
#define   BIT10       0x00000400
#define   BIT11       0x00000800
#define   BIT12       0x00001000
#define   BIT13       0x00002000
#define   BIT14       0x00004000
#define   BIT15       0x00008000
#define   BIT16       0x00010000
#define   BIT17       0x00020000
#define   BIT18       0x00040000
#define   BIT19       0x00080000
#define   BIT20       0x00100000
#define   BIT21       0x00200000
#define   BIT22       0x00400000
#define   BIT23       0x00800000
#define   BIT24       0x01000000
#define   BIT25       0x02000000
#define   BIT26       0x04000000
#define   BIT27       0x08000000
#define   BIT28       0x10000000
#define   BIT29       0x20000000
#define   BIT30       0x40000000
#define   BIT31       0x80000000

#define   SET_TIME    1000
#define   LED_TIME    100000
#define   BUZZ_TIME   700
#define   BEEP        100
#define   _1s         1000
#define   BUT1        IO0PIN_bit.P0_15
#define   BUT2        IO0PIN_bit.P0_16
#define   LED1_ON     IO0CLR_bit.P0_10 = 1;
#define   LED1_OFF    IO0SET_bit.P0_10 = 1;
#define   LED2_ON     IO0CLR_bit.P0_11 = 1;
#define   LED2_OFF    IO0SET_bit.P0_11 = 1;
#define   BUZZ1_HIGH   IO0SET_bit.P0_12 = 1;
#define   BUZZ1_LOW    IO0CLR_bit.P0_12 = 1;
#define   BUZZ2_HIGH   IO0SET_bit.P0_13 = 1;
#define   BUZZ2_LOW    IO0CLR_bit.P0_13 = 1;
#define   ON          1
#define   OFF         0
#define   CP          IO1PIN & BIT25
#define   WP          IO1PIN & BIT24

unsigned int l,k = 0;
unsigned char b1=0;
unsigned char b2=0;
unsigned char i, pot;
unsigned long compare, CONST;
////////////////////////////////////////////////////////////////////////////////////

/**** INTERRUPTS HANDLERS ****/
// IRQ interrupt handler.
//__irq __arm void irq_handler(void)        //for eqva
#pragma vector=0x18
__irq __arm void IRQ_ISR_Handler (void)     //for LPC2xxx
{
  void (*interrupt_function)();
  unsigned int vector;

  // Called at 1000 Hz rate.
  vector = VICVectAddr; // Get interrupt vector.
  interrupt_function = (void(*)())vector;
  (*interrupt_function)(); // Call vectored interrupt function.

  VICVectAddr = 0; // Clear interrupt in VIC.
}

// FIQ interrupt handler.
//__fiq __arm void fiq_handler (void)   //for eqva
#pragma vector=0x1c
__fiq __arm void FIQ_ISR_Handler (void)
{
void (*interrupt_function)();
unsigned int vector;

  vector = VICVectAddr;     // Get interrupt vector.
  interrupt_function = (void(*)())vector;
  (*interrupt_function)();  // Call vectored interrupt function.
}

void RTCInterrupt()
{
  (*RTC_function)();
}


void rtc_int()
{
  if(l == 0)
  {
    LED1_ON;    //on led
    LED2_ON;    //on led
    l = 1;
  }
  else
  {
   LED1_OFF;    //off led
   LED2_OFF;    //off led
   l = 0;
  }

  ILR=0x3;                 // clear all interrupt of RTC
}


/////////////////////////////////////////////////////////////////////////////////////

unsigned char ch_1 = 0;
unsigned char ch_2 = 0;

extern char mmc_buffer[512];
char mmc_buffer_test_1[512];
char mmc_buffer_test_2[512];

char state_mmc  = 1;

unsigned char state_vcc = 0;
unsigned char state_gnd = 0;
unsigned char state_err = 0;
unsigned char state_i2c = 0;

unsigned char pin = 0;

void Delay_ (unsigned long a) { while (--a!=0); }

void BUZZER (unsigned int b)
{
  while (--b!=0)
    {
      BUZZ1_HIGH;
      BUZZ2_LOW;
      Delay_(BUZZ_TIME);
      BUZZ2_HIGH;
      BUZZ1_LOW;
      Delay_(BUZZ_TIME);
    }
}


void STOP0(void) {

  unsigned char dec = 0;
  unsigned char edi = 0;


  FrecInit();                     //Init frequency

  if(state_vcc)  UART0SendTxt("\n\rPIN to VCC\n\r"); //write to uart0
  if(state_gnd)  UART0SendTxt("\n\rPIN to GND\n\r"); //write to uart0
  if(state_i2c)  UART0SendTxt("\n\rI2C ERR\n\r");    //write to uart0
  if(state_err)  {

    dec = pin/10;
    edi = pin - 10*dec;

    UART0SendTxt("PORT0 Pin "); //write to LCD
    UART0WriteChar(dec+48);
    UART0WriteChar(edi+48);
    UART0SendTxt(" error\r\n"); //write to LCD
  }

  IO0DIR = 0x0;  // all port to input
  IO1DIR = 0x0;  // all port to input
  while(1);
}

void STOP1(void) {

  unsigned char dec = 0;
  unsigned char edi = 0;


  FrecInit();                     //Init frequency

  if(state_vcc)  UART0SendTxt("\n\rPIN to VCC\n\r"); //write to uart0
  if(state_gnd)  UART0SendTxt("\n\rPIN to GND\n\r"); //write to uart0
  if(state_i2c)  UART0SendTxt("\n\rI2C ERR\n\r");    //write to uart0
  if(state_err)  {

    dec = pin/10;
    edi = pin - 10*dec;

    UART0SendTxt("PORT1 Pin "); //write to LCD
    UART0WriteChar(dec+48);
    UART0WriteChar(edi+48);
    UART0SendTxt(" error\r\n"); //write to LCD
  }

  IO0DIR = 0x0;  // all port to input
  IO1DIR = 0x0;  // all port to input
  while(1);
}

int main()
{

/**** Initialization ****/
  PINSEL2 = BIT2; //enable p1 as I/O
  PINSEL0 = 0;
  PINSEL1 = 0;
  IO0DIR = 0x0;  // all port to input
  IO1DIR = 0x0;  // all port to input

  FrecInit();                     //Init frequency
  UART0Initialize(9600);          //Init UART0
  UART1Initialize(9600);          //Init UART1

  IO0DIR_bit.P0_15 = 0;           //Init button 1 as input
  IO0DIR_bit.P0_16 = 0;           //Init button 2 as input
  IO0DIR_bit.P0_30 = 0;           //Init potential as input
  LED1_OFF;
  LED2_OFF;
  IO0DIR_bit.P0_10 = 1;           //Init LED1 as output
  IO0DIR_bit.P0_11 = 1;           //Init LED1 as output
  IO0DIR_bit.P0_12 = 1;           //Init BUZ1 as output
  IO0DIR_bit.P0_13 = 1;           //Init BUZ2 as output

  IO1DIR_bit.P0_25 = 0;           //CP as input
  IO1DIR_bit.P0_24 = 0;           //WP as input


  BUZZER(_1s);

  //RTC INIT
  InitRTC();                    //RTC Ini


  /**** INTERRUPTS ****////
  MEMMAP = 1;                         //This will move the exception vectors in place.
  __disable_interrupt();              //Disable interrupts.
  InitRTCInterrupt(rtc_int);          //Setup interrupt controller.
  __enable_interrupt();               //Enable interrupts.

  while(1)
  {
    if((BUT1) == 0 && b1==OFF)
     {
//      LED1_ON;
      BUZZER(BEEP);
      b1=ON;
     }
    if((BUT1) != 0 && b1==ON)
     {
//      LED1_OFF;
      BUZZER(BEEP);
      b1=OFF;
     }

    if((BUT2) == 0 && b2==OFF)
     {
//      LED2_ON;
      BUZZER(BEEP);
      b2=ON;
     }
    if((BUT2) != 0 && b2==ON)
     {
//      LED2_OFF;
      BUZZER(BEEP);
      b2=OFF;
     }

    while ((BUT1)==0 && (BUT2)==0) BUZZER(_1s);

    //rs232 - UART0
    ch_1 = UART0ReadChar_nostop();
    if(ch_1 != 0) { UART0WriteChar(ch_1); UART0WriteChar('*'); ch_1 = 0; }
    //rs232 - UART0
    ch_2 = UART1ReadChar_nostop();
    if(ch_2 != 0) { UART1WriteChar(ch_2); UART1WriteChar('*'); ch_2 = 0; }

    //potentiometer
//    if(IO0PIN_bit.P0_30 == 0 && pot==ON) {LED1_ON; Delay_(LED_TIME); LED1_OFF; pot=OFF;}
//    if(IO0PIN_bit.P0_30 != 0 && pot==OFF) {LED2_ON; Delay_(LED_TIME); LED2_OFF; pot=ON;}

    //potentiometer
    if(IO0PIN_bit.P0_30 == 0 && pot==ON) {BUZZER(BEEP); pot=OFF;}
    if(IO0PIN_bit.P0_30 != 0 && pot==OFF) {BUZZER(BEEP); pot=ON;}

  }
}
